#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n;

int a[maxn];

vector<int> g[maxn];

int depth[maxn];

int idx = 0;
int stick[maxn];

void dfs2(int node, int par, int d)
{
    stick[++idx] = node;
    depth[node] = d;

    for (auto next_node : g[node])
    {
        if (next_node != par)
        {
            dfs2(next_node, node, d + 1);
        }
    }
}

int ans = 0;
int curr_node = -1;

int sparse[maxn][20];

int liftind(int from, int lift)
{
    int ans = 0;

    for (int i = 19; i >= 0; --i)
    {
        if ((lift & (1 << i)) != 0)
        {
            ans = __gcd(ans, sparse[from][i]);
            from += (1 << i);
        }
    }

    return ans;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sparse[i][0] = a[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= 19; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            sparse[j][i] = __gcd(sparse[j][i - 1], sparse[sparse[j][i - 1]][i - 1]);
        }
    }

    dfs2(1, -1, 0);

    for (int i = 1; i <= n; ++i)
    {
        int l = i + 1;
        int r = n;

        while (l <= r)
        {
            int mid = (l + r) / 2;

            if (liftind(i, mid - i) != 1)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        ans = max(ans, depth[r] - depth[i]);
    }

    cout << ans << endl;

    return 0;
}
