#include<bits/stdc++.h>
using namespace std;

int n, k;
int a[701][701];
int prefix[701][701];
bool used[701];

int get_prefix (int x1, int y1, int x2, int y2) {
    return prefix[x2][y2] - prefix[x1 - 1][y2] - prefix[x2][y1 - 1] + prefix[x1 - 1][y1 - 1];
}

int rec (int i, int ans, int k, int last_get) {
    if (k == 0) return ans;
    if (i > n) return ans;

    int curr = rec(i + 1, ans, k, last_get);
    for (int s = 0; s <= i && i - s + 1 > last_get; s ++) {
        curr = max(curr, rec(i + 1, ans + get_prefix(i - s + 1, i - s + 1, i, i), k - 1, i));
    }

    return curr;
}

int main () {
    cin >> n >> k;

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cin >> a[i][j];
            prefix[i][j] = prefix[i][j - 1] + prefix[i - 1][j] - prefix[i - 1][j - 1] + a[i][j];
        }
    }
    /*
    cout << endl;
    cout << endl;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cout << setw(3) << a[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cout << setw(3) << prefix[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    */



    cout << rec(1, 0, k, -1) << endl;

    return 0;
}
