# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;

const int MAX=2*1e6+1;
vector<int> a[MAX];
int c[MAX];
int n;
int dist[MAX];
int ans=0;

void dfs(int curr, int par, int d, int br=0)
{
    if(d>1) ans=max(ans,br);
    dist[curr]=dist[par]+1;
    for(auto next: a[curr])
    {
        if((dist[next]==-1 or dist[next]>dist[curr]) and __gcd(d,c[next])!=1) dfs(next,curr, __gcd(d,c[next]),br+1);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>c[i];
    }
    for(int i=1;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    for(int i=0;i<=n;i++)
    {
        dist[i]=-1;
    }

    for(int i=1;i<=n;i++)
    {
        dfs(i,0,c[i],0);
    }
    cout<<ans<<endl;
    return 0;
}
