# include <iostream>
using namespace std;

const long long INF=1e15;
const int MAX=701;
long long tab[MAX][MAX];
long long p[MAX][MAX];
long long n,k;
long long dp[MAX];

void pfx()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            p[i][j]=p[i-1][j]+p[i][j-1]-p[i-1][j-1]+tab[i][j];
        }
    }
}

long long sum(long long x1, long long y1, long long x2, long long y2) //raboti
{
    return p[x2][y2]-p[x2][y1-1]-p[x1-1][y2]+p[x1-1][y1-1];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin>>tab[i][j];
        }
    }

    pfx();

    for(int i=0;i<=n;i++)
    {
        dp[i]=-INF;
    }

    for(int i=1;i<=n;i++)
    {
        for(int s=0;s<i;s++)
        {
            dp[i]=max(dp[i],sum(i-s,i-s,i,i));
            for(int j=1;j<=i-s-1;j++)
            {
                dp[i]=max(dp[i],sum(i-s,i-s,i,i)+dp[j]);
            }
        }
        cout<<i<<" "<<dp[i]<<endl;
    }

    long long ans=-INF;
    for(int i=1;i<=n;i++)
    {
        ans=max(ans,dp[i]);
    }
    cout<<ans<<endl;
    return 0;
}

