# include <iostream>
# include <climits>
using namespace std;

const int MAX=701, MAXK=201;
const int INF=INT_MAX;
int tab[MAX][MAX];
int p[MAX][MAX];
int n,k;
int dp[MAX][MAXK];
int maxi[MAX][MAXK];

void pfx()
{
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            p[i][j]=p[i-1][j]+p[i][j-1]-p[i-1][j-1]+tab[i][j];
        }
    }
}

int sum(int x1, int y1, int x2, int y2) //raboti
{
    return p[x2][y2]-p[x2][y1-1]-p[x1-1][y2]+p[x1-1][y1-1];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cin>>tab[i][j];
        }
    }

    pfx();
    for(int i=0; i<=n; i++)
    {
        for(int p=1; p<=k; p++)
        {
            dp[i][p]=-INF;
            maxi[i][p]=-INF;
        }
    }

    for(int i=0; i<=n; i++)
    {
        for(int p=1; p<=k; p++)
        {
            for(int s=0; s<i; s++)
            {
                if(maxi[i-s-1][p-1]!=-INF)
                {
                    dp[i][p]=max(dp[i][p],sum(i-s,i-s,i,i)+maxi[i-s-1][p-1]);
                    maxi[i][p]=max(maxi[i-1][p],dp[i][p]);
                }
            }
        }
    }

    int ans=-INF;
    for(int i=0; i<=n; i++)
    {
        for(int p=1; p<=k; p++)
        {
            ans=max(ans,dp[i][p]);
        }
    }

    cout<<ans<<endl;
    return 0;
}
