#include <bits/stdc++.h>

using namespace std;

const int maxn = 701;
long long dp[maxn][maxn], pref[maxn][maxn], a[maxn][maxn];
int n, k;

void read(){
    cin >> n >> k;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            cin >> a[i][j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
        }
    }
}

void solve(){
    for(int i = 1;i <= n;i++){
        for(int p = 1;p <= k;p++){
            for(int s = 0;s < i;s++){
                int maxb = i, minb = max(i - s - 1, 0);
                long long cost = pref[maxb][maxb] - pref[minb][maxb] - pref[maxb][minb] + pref[minb][minb];
                dp[i][p] = max(dp[i][p], cost + dp[minb][p - 1]);
            }
            dp[i][p] = max(dp[i][p], dp[i - 1][p]);
        }
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++)
        ans = max(ans, dp[i][k]);
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
