#include <bits/stdc++.h>

using namespace std;

const int maxn = 51;
long long dp[maxn][maxn][maxn], pref[maxn][maxn], a[maxn][maxn];
int n, k;

void read(){
    cin >> n >> k;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            cin >> a[i][j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
        }
    }
}

long long f(int i, int s){
    int maxb = i, minb = max(i - s - 1, 0);
    long long cost = pref[maxb][maxb] - pref[minb][maxb] - pref[maxb][minb] + pref[minb][minb];
    return cost;
}

void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j < i;j++){
            dp[i][1][j] = f(i, j);
        }
    }
    long long ans = 0;
    for(int lamp = 2;lamp <= k;lamp++){
        for(int i = 1;i <= n;i++){
            for(int last = 1;last < i;last++){
                for(int teks = 0;teks < i;teks++){
                    for(int lasts = 0;lasts < last;lasts++){
                        int tek = 0;
                        if(i - teks > last){
                            tek = f(i, teks);
                        }
                        else{
                            if(lasts < teks)
                                continue;
                            tek = pref[i][i] - pref[i - teks - 1][i] - pref[i][last] + pref[i - teks - 1][last];
                            tek = tek + pref[i][last] - pref[i][i - teks - 1] - pref[last][last] + pref[last][i - teks - 1];
                        }
                        dp[i][lamp][teks] = max(dp[i][lamp][teks], dp[last][lamp - 1][lasts] + tek);
                        ans = max(ans, dp[i][lamp][teks]);
                    }
                }
            }
        }
    }
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
