#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+2;
int N;
int A[MAXN];
int level[MAXN];
int ans=0;
vector<int> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> A[i];
    }

    vector<pair<int, int>> v;

    for(int i=1; i<N; i++)
    {
        int parent, child;
        cin >> parent >> child;
        v.push_back({parent, child});
    }

    level[1]=1;

    sort(v.begin(), v.end());

    while(true)
    {
        bool is_over=false;

        for(int i=0; i<v.size(); i++)
        {
            if(level[v[i].first]>0 && level[v[i].second]>0)
            {
                continue;
            }

            if(level[v[i].first]>0)
            {
                level[v[i].second]=level[v[i].first]+1;
                edges[v[i].first].push_back(v[i].second);
                is_over=true;
            }
            else if(level[v[i].second]>0)
            {
                level[v[i].first]=level[v[i].second]+1;
                edges[v[i].second].push_back(v[i].first);
                is_over=true;
            }
        }

        if(is_over)
        {
            break;
        }
    }

}

void dfs(int u, int w, int gcd)
{
    if(gcd==0)
    {
        gcd=A[u];
    }

    if(gcd<=1)
    {
        return;
    }

    ans=max(ans, w);

    for(auto& v:edges[u])
    {
        int newgcd=__gcd(gcd, A[v]);
        dfs(v, w+1, newgcd);
    }
}

void solve()
{
    for(int i=1; i<=N; i++)
    {
        dfs(i, 0, 0);
    }

    cout << ans;
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}
