#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+2;
int N;
int A[MAXN];
int visited[MAXN], counter=1;
int ans=0;
map<pair<int, int>, int> dp;
vector<int> before_edges[MAXN], edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> A[i];
    }

    for(int i=1; i<N; i++)
    {
        int parent, child;
        cin >> parent >> child;
        before_edges[parent].push_back(child);
        before_edges[child].push_back(parent);
    }
}

void build_tree(int u, int parent)
{
    if(visited[u]==counter)
    {
        return;
    }

    visited[u]=counter;

    if(u!=1)
    {
        edges[parent].push_back(u);
    }

    for(auto& v:before_edges[u])
    {
        build_tree(v, u);
    }
}

void dfs(int u)
{
    ///cout << u << " " << w << " " << gcd << '\n';

    for(auto& v:edges[u])
    {
        for(int i=2; i*i<=A[u]; i++)
        {
            if(A[u]%i!=0)
            {
                continue;
            }

            if(A[v]%i==0)
            {
                dp[ {v, i}]=max(dp[ {v, i}], dp[ {u, i}]+1);
                ans=max(ans, dp[ {v, i}]);
            }

            if(i*i!=A[u])
            {
                int div=A[u]/i;

                if(A[v]%div==0)
                {
                    dp[ {v, div}]=max(dp[ {v, div}], dp[ {u, div}]+1);
                    ans=max(ans, dp[ {v, div}]);
                }
            }
        }

        dfs(v);
    }
}

void solve()
{
    dfs(1);
    cout << ans;
}

int main()
{
    fastIO();
    read();
    build_tree(1, 0);
    solve();
    return 0;
}
