#include <bits/stdc++.h>
using namespace std;

const int MAXN=701;
int N, K;
int Field[MAXN][MAXN];
int dp[MAXN][MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N >> K;

    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            cin >> Field[i][j];
        }
    }
}

void draw()
{
    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(Field[i][j]>0)
            {
                cout << Field[i][j] << " ";
            }
            else
            {
                cout << 0 << " ";
            }
        }

        cout << '\n';
    }
}

void solve()
{
    for(int i=1; i<=N; i++)
    {
        for(int k=1; k<=min(i, K); k++)
        {
            dp[i][k]=dp[i-1][k];

            int x1=i, y1=i, x2=i, y2=i;
            int add=0;

            while(y1>=1 && x2>=1)
            {
                if(x1==x2)
                {
                    add+=Field[x1][y1];
                }
                else
                {
                    add+=(Field[x1][y1]+Field[x2][y2]);
                }

                dp[i][k]=max(dp[i][k], dp[i-1][k-1]+add);
                y1--;
                x2--;
            }

            ///cout << i << " " << k << " " << dp[i][k] << '\n';
        }
    }

    cout << dp[N][K];
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

