#include <bits/stdc++.h>
using namespace std;

const int MAXN=701;
int N, K;
int Field[MAXN][MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N >> K;

    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            cin >> Field[i][j];
        }
    }
}

void draw()
{
    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(Field[i][j]>0)
            {
                cout << Field[i][j] << " ";
            }
            else
            {
                cout << 0 << " ";
            }
        }

        cout << '\n';
    }
}

void solve()
{
    int ans=0;

    for(int i=1; i<=N; i++)
    {
        int curr=0;

        for(int x=i; x>=1; x--)
        {
            for(int y=i; y>=1; y--)
            {
                curr+=Field[x][y];

                if(x==y)
                {
                    ans=max(ans, curr);
                }
            }
        }
    }

    cout << ans;
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

