#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1e5+5;
const int maxm = 2*1e6+5;
int n,a[maxn],used[maxm];
bool vis[maxn];
vector<int>g[maxn];
vector<int>v1,v2;
int ans;
int last = 1;

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++) cin >> a[i];
    int x,y;
    for(int i=1;i<n;i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
}

void dfs_par1(int beg)
{
    vis[beg] = 1;
    v1.push_back(beg);
    for(int nb:g[beg])
    {
        if(!vis[nb]) dfs_par1(nb);
    }
}

void dfs_par2(int beg)
{
    vis[beg] = 1;
    v2.push_back(beg);
    for(int nb:g[beg])
    {
        if(!vis[nb]) dfs_par2(nb);
    }
}

int check(int i, int idx)
{
    int ch = a[idx];
    int br = 0, d = 2;
    while(ch%d==0)
    {
        ch /= d;
        br++;
    }
    if(br&&used[d]==i-last+1) return  i-last;
    d++;
    br = 0;
    if(d>=1420&&used[ch]==i-last+1) return i-last;
    while(ch>1)
    {
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br&&used[d]==i-last+1) return  i-last;
        d += 2;
        br = 0;
        if(d>=1420&&used[ch]==i-last+1) return i-last;
    }
    return 0;
}

void used_fill(int i)
{
    int ch = a[i];
    int d = 2;
    int br = 0;
    while(ch%d==0)
    {
        ch /= d;
        br++;
    }
    if(br) used[d]++;
    d++;
    br = 0;
    if(d>=1420)
    {
        used[ch]++;
        ch = 1;
    }
    while(ch>1)
    {
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br) used[d]++;
        d += 2;
        br = 0;
        if(d>=1420)
        {
            used[ch]++;
            ch = 1;
        }
    }
}

void used_del(int i)
{
    int ch = a[i];
    int d = 2;
    int br = 0;
    while(ch%d==0)
    {
        ch /= d;
        br++;
    }
    if(br) used[d]--;
    d ++;
    br = 0;
    if(d>=1420)
    {
        used[ch]--;
        ch = 1;
    }
    while(ch>1)
    {
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br) used[d]--;
        d += 2;
        br = 0;
        if(d>=1420)
        {
            used[ch]--;
            ch = 1;
        }
    }
}

void solve()
{
    vis[1] = 1;
    int nb1 = g[1][0];
    int nb2 = 0;
    if(g[1].size()==2) nb2 = g[1][1];
    dfs_par1(nb1);
    dfs_par2(nb2);
    last = -1;
    used_fill(1);
    for(int i=0;i<v1.size();i++)
    {
        used_fill(v1[i]);
        while(last<i&&check(i,v1[i])==0)
        {
            if(last==-1) used_del(1);
            else used_del(v1[last]);
            last++;
        }
        //cout << last << " " << i << endl;
        ans = max(ans,i-last);
    }
    //cout << ans << endl;
    if(nb2==0)
    {
        cout << ans << endl;
        return;
    }
    //cout << "++++" << endl;
    memset(used,0,sizeof(used));
    last = -1;
    used_fill(1);
    for(int i=0;i<v2.size();i++)
    {
        used_fill(v2[i]);
        while(last<i&&check(i,v2[i])==0)
        {
            if(last==-1) used_del(1);
            else used_del(v1[last]);
            last++;
        }
        ans = max(ans,i-last);
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
