#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n;

int a[maxn];

vector<int> g[maxn];

int depth[maxn];

void dfs2(int node, int par, int d)
{
    depth[node] = d;

    for (auto next_node : g[node])
    {
        if (next_node != par)
        {
            dfs2(next_node, node, d + 1);
        }
    }
}

int ans = 0;
int curr_node = -1;

void dfs(int node, int par, int gcd)
{
    if (gcd != 1)
    {
        ans = max(ans, depth[node] - depth[curr_node]);
    }

    for (auto next_node : g[node])
    {
        if (next_node != par)
        {
            int d = __gcd(gcd, a[next_node]);

            if (d != 1)
            {
                dfs(next_node, node, d);
            }
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    dfs2(1, -1, 0);

    for (int i = 1; i <= n; ++i)
    {
        curr_node = i;
        dfs(i, -1, a[i]);
    }

    cout << ans << endl;

    return 0;
}
