#include <bits/stdc++.h>

using namespace std;

const int maxn = 705;

int n, k;

int a[maxn][maxn];
int p[maxn][maxn];

int calc(int x1, int y1, int x2, int y2)
{
    return p[x2][y2] - p[x1 - 1][y2] - p[x2][y1 - 1] + p[x1 - 1][y1 - 1];
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
            p[i][j] = p[i - 1][j] + p[i][j - 1] + a[i][j] - p[i - 1][j - 1];
        }
    }

    int ans = 0;

    vector<int> v;

    for (int i = 1; i <= n; ++i)
    {
        v.push_back(a[i][i]);
    }

    sort(v.begin(), v.end(), greater<int>());

    for (int i = 0; i < k; ++i)
    {
        ans += v[i];
    }

    cout << ans << endl;

    return 0;
}
/*
8 1
12 -3 3 -9 0 2 3 -4
-11 3 -5 1 -6 1 -7 7
 4 -8 1 4 -8 2 3 -5
 6 6 -6 1 10 -4 -4 4
 1 0 -8 -5 9 5 -3 -11
2 -2 6 7 -4 8 6 2
-5 -7 4 0 9 -1 -1 9
-10 4 1 -7 4 -5 6 7
*/
