#include<bits/stdc++.h>
using namespace std;

int n, k;
int a[701][701];
int prefix[701][701];
bool used[701];

int get_prefix (int x1, int y1, int x2, int y2) {
    return prefix[x2][y2] - prefix[x1 - 1][y2] - prefix[x2][y1 - 1] + prefix[x1 - 1][y1 - 1];
}

int get_with_s (int x, int s) {
    return get_prefix(x - s + 1, x - s + 1, x, x) - get_prefix(x - s + 1, x - s + 1, x - 1, x - 1);
}

int rec (int x, int ans, int maxNaLqvo) {
    if (x > n) return ans;

    int ret = 0;
    for (int s = 0; s <= x && x - s + 1 >= maxNaLqvo; s ++) {
        ret = max(ret, rec (x + 1, ans + get_with_s(x, s), x - s + 1));
    }
    return ret;
}

int main () {
    cin >> n >> k;

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cin >> a[i][j];
            prefix[i][j] = prefix[i][j - 1] + prefix[i - 1][j] - prefix[i - 1][j - 1] + a[i][j];
        }
    }
    /*
    cout << endl;
    cout << endl;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cout << setw(3) << a[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= n; j ++) {
            cout << setw(3) << prefix[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    */

    cout << rec(1, 0, -1) << endl;

    return 0;
}
