# include <iostream>
# include <vector>
# include <algorithm>
# include <map>
# include <queue>
using namespace std;

const int MAX=2*1e6+111;
vector<int> a[MAX];
int c[MAX];
int n;
int dist[MAX];
int ans=0;
vector<int> primes[MAX];
int p[MAX];

void Erat()
{
    for(int i=2; i<=MAX-1; i++)
    {
        if(p[i]==0)
        {
            p[i]=i;
            for(int j=i*2; j<=MAX-1; j=j+i)
            {
                p[j]=i;
            }
        }
    }

    for(int i=2; i<=MAX-1; i++)
    {
        int k=i;
        while(k!=1)
        {
            primes[k].push_back(p[k]);
            k=k/p[k];
        }
    }
}

void dfs_dist(int curr, int par)
{
    dist[curr]=dist[par]+1;
    for(auto next: a[curr])
    {
        if(dist[next]==-1) dfs_dist(next,curr);
    }
}

queue<pair<int, int>> q;
map<pair<int, int>, bool> vis;
void dfs(int curr, int d, int br)
{
    //cout<<curr<<" "<<d<<endl;
    ans=max(ans,br);
    vis[ {curr,d}]=1;
    for(int x: primes[c[curr]])
    {
        if(vis[{curr,x}]==0)
        {
            //cout<<"Here"<<endl;
            q.push({curr,x});
            vis[{curr,x}]=1;
        }
    }

    for(int next: a[curr])
    {
        if(dist[next]>dist[curr] and c[next]%d==0) dfs(next,d,br+1);
        else
        {
            for(int x: primes[c[next]])
            {
                if(vis[{next,x}]==0)
                {
                    q.push({next,x});
                    vis[{next,x}]=1;
                }
            }

            if(q.size()>0)
            {
                int next,d2;
                tie(next,d2)=q.front();
                q.pop();
                dfs(next,d2,0);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    Erat();
    // cout<<primes.size()<<endl;

    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>c[i];
    }
    for(int i=1; i<n; i++)
    {
        int x,y;
        cin>>x>>y;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    for(int i=0; i<=n; i++)
    {
        dist[i]=-1;
    }

    dfs_dist(1,0);
    dfs(1,1e8,0);
    cout<<ans<<endl;
    return 0;
}

