# include <iostream>
using namespace std;

const int MAX=701;
long long tab[MAX][MAX];
long long p[MAX][MAX];
long long n,k;

void pfx()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            p[i][j]=p[i-1][j]+p[i][j-1]-p[i-1][j-1]+tab[i][j];
        }
    }
}

long long sum(long long x1, long long y1, long long x2, long long y2)
{
    return p[x2][y2]-p[x2][y1-1]-p[x1-1][y2]+p[x1-1][y1-1];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin>>tab[i][j];
        }
    }

    pfx();
    long long ans=-1e18;
    for(int i=1;i<=n;i++)
    {
        for(int s=1;s<i;s++)
        {
            ans=max(ans,sum(i-s,i-s,i,i));
        }
    }
    cout<<ans<<endl;
    return 0;
}
