#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e6 + 10;
int n, a[maxn], used[maxn];
vector<int> v[maxn];
vector< pair<int, int> > gcd[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++)
        cin >> a[i];
    for(int i = 1;i <= n - 1;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

int ans = 0;
void dfs(int ver, int p){
    vector<int> diff;
    for(int nb : v[ver]){
        if(nb == p)
            continue;
        dfs(nb, ver);
        for(pair<int, int> x : gcd[nb]){
            int value = __gcd(x.first, a[ver]);
            if(value == 1)
                continue;
            if(!used[value])
                diff.push_back(value);
            used[value] = max(used[value], x.second);
        }
    }
    if(!used[a[ver]])
        diff.push_back(a[ver]);
    for(int x : diff){
        gcd[ver].push_back({x, used[x] + 1});
        ans = max(ans, used[x] + 1);
        used[x] = 0;
    }
}

void solve(){
    dfs(1, 0);
    cout << ans - 1 << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
