#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e6 + 10, maxm = 1e3 + 10;
int n, a[maxm], used[maxn];
vector<int> v[maxm];
vector< pair<int, int> > gcd[maxm];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++)
        cin >> a[i];
    for(int i = 1;i <= n - 1;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

int ans = 0;

void dfs(int ver, int p){
    vector<int> diff;

    for(int nb : v[ver]){
        if(nb == p)
            continue;
        dfs(nb, ver);
    }
    set<int> s;
    for(int nb : v[ver]){
        if(nb == p)
            continue;
        for(pair<int, int> x : gcd[nb]){
            int value = __gcd(x.first, a[ver]);
            if(value == 1)
                continue;
            if(s.find(value) == s.end()){
                diff.push_back(value);
                used[value] = 0;
                s.insert(value);
            }
            used[value] = max(used[value], x.second + 1);
        }
    }
    if(s.find(a[ver]) == s.end())
        diff.push_back(a[ver]);
    for(int x : diff){
        gcd[ver].push_back({x, used[x]});
        ans = max(ans, used[x]);
    }
}

void solve(){
    dfs(1, 0);
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
