#include <bits/stdc++.h>

using namespace std;

const int maxn = 701;
long long n, k, dp[maxn][maxn], pref[maxn][maxn], a[maxn][maxn];

void read(){
    cin >> n >> k;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            cin >> a[i][j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
        }
    }
}

void solve(){
    for(int i = 1;i <= n;i++){
        for(int p = 1;p <= k;p++){
            for(int s = 0;s < i;s++){
                if(i + s > n)
                    continue;
                long long cost = pref[i + s][i + s] - pref[i - s - 1][i + s] - pref[i + s][i - s - 1] + pref[i - s - 1][i - s - 1];
                dp[i][p] = max(dp[i][p], cost + dp[i - s - 1][p - 1]);
            }
            dp[i][p] = max(dp[i][p], dp[i - 1][p]);
        }
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++)
        ans = max(ans, dp[i][k]);
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
