#include <bits/stdc++.h>

using namespace std;

const int maxn = 701;
long long dp[maxn][2][maxn], pref[maxn][maxn], a[maxn][maxn];
int n, k;

void read(){
    cin >> n >> k;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            cin >> a[i][j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
        }
    }
}

long long f(int i, int s){
    int maxb = i, minb = max(i - s - 1, 0);
    long long cost = pref[maxb][maxb] - pref[minb][maxb] - pref[maxb][minb] + pref[minb][minb];
    return cost;
}

void solve(){
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        for(int j = 0;j < i;j++){
            dp[i][1][j] = f(i, j);
            ans = max(ans, dp[i][1][j]);
        }
    }

     for(int lamp = 2;lamp <= k;lamp++){
         for(int i = 1;i < n;i++)
            for(int teks = 0;teks < i;teks++)
                dp[i][lamp % 2][teks] = 0;
         for(int last = 1;last < n;last++){
            for(int i = last + 1;i <= n;i++){
                long long maxx = 0, idx = last - 1;
                for(int teks = i - 1;teks >= 0;teks--){
                    while(idx >= 0 && last - idx < i - teks){
                        maxx = max(maxx, dp[last][1 - lamp % 2][idx]);
                        idx--;
                    }
                    long long tek = 0;
                    if(i - teks > last){
                        tek = f(i, teks);
                    }
                    else{
                        tek = pref[i][i] - pref[i - teks - 1][i] - pref[i][last] + pref[i - teks - 1][last];
                        tek = tek + pref[i][last] - pref[i][i - teks - 1] - pref[last][last] + pref[last][i - teks - 1];
                    }
                    if(maxx)
                        dp[i][lamp % 2][teks] = max(dp[i][lamp % 2][teks], maxx + tek);
                    ans = max(ans, dp[i][lamp % 2][teks]);
                }
            }
        }
    }
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
