#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+2;
int N;
int A[MAXN];
int ans=0;
vector<int> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> A[i];
    }

    for(int i=1; i<N; i++)
    {
        int parent, child;
        cin >> parent >> child;

        if(__gcd(A[parent], A[child])==1)
        {
            continue;
        }

        edges[parent].push_back(child);
    }
}

void dfs(int u, int w, int gcd)
{
    if(gcd==0)
    {
        gcd=A[u];
    }

    if(gcd<=1)
    {
        return;
    }

    ans=max(ans, w);

    for(auto& v:edges[u])
    {
        int newgcd=__gcd(gcd, A[v]);
        dfs(v, w+1, newgcd);
    }
}

void solve()
{
    for(int i=1; i<=N; i++)
    {
        dfs(i, 0, 0);
    }

    cout << ans;
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

