#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+2;
int N;
int A[MAXN];
int dp[MAXN];
vector<int> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> A[i];
    }

    for(int i=1; i<N; i++)
    {
        int parent, child;
        cin >> parent >> child;

        if(__gcd(A[parent], A[child])==1)
        {
            continue;
        }

        edges[child].push_back(parent);
    }
}

void solve()
{
    int ans=0;

    for(int i=1; i<=N; i++)
    {
        for(auto& u:edges[i])
        {
            if(A[u]==A[i])
            {
                dp[i]=max(dp[i], dp[u]+1);
            }
        }

        ans=max(ans, dp[i]);
    }

    cout << ans;
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

