#include <bits/stdc++.h>
using namespace std;

const int MAXN=701;
int N, K;
int Field[MAXN][MAXN];
long long dp[MAXN][MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N >> K;

    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            cin >> Field[i][j];
        }
    }
}

void draw()
{
    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(Field[i][j]>0)
            {
                cout << Field[i][j] << " ";
            }
            else
            {
                cout << 0 << " ";
            }
        }

        cout << '\n';
    }
}

void solve()
{
    long long ans=0;

    for(int i=1; i<=N; i++)
    {
        for(int k=1; k<=K; k++)
        {
            long long curr=Field[i][i];
            int l=1;
            dp[i][k]=max(dp[i][k], dp[i-1][k-1]+curr);

            while(l<i)
            {
                int x1=i, y1=i-l, x2=i-l, y2=i;

                while(x1!=x2)
                {
                    curr+=(Field[x1][y1]+Field[x2][y2]);
                    x1--;
                    y2--;
                }

                curr+=Field[x1][y1];
                ///cout << i << " " << l << " " << curr << '\n';

                l++;
                dp[i][k]=max(dp[i][k], dp[i-l][k-1]+curr);
            }
        }
    }

    for(int i=1; i<=K; i++)
    {
        ans=max(ans, dp[N][i]);
    }

    cout << ans;
}

int main()
{
    fastIO();
    read();
    solve();
    return 0;
}

