#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 2*1e6+5;
int n,a[maxn];
int par[maxn];
int dp[maxn];
int used[maxn];
vector<int>g[maxn];
vector<int>v1,v2;
int ans;
int last = 1;

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++) cin >> a[i];
    int x,y;
    for(int i=1;i<n;i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
}

void dfs_par1(int beg, int p)
{
    par[beg] = p;
    v1.push_back(beg);
    for(int nb:g[beg])
    {
        if(nb!=p) dfs_par1(nb,beg);
    }
}

void dfs_par2(int beg, int p)
{
    par[beg] = p;
    v2.push_back(beg);
    for(int nb:g[beg])
    {
        if(nb!=p) dfs_par2(nb,beg);
    }
}

bool prime(int x)
{
    if(x<=1) return false;
    if(x<=3) return true;
    if(x%2==0) return false;
    int d = 3;
    while(d*d<=x&&x%d!=0)
    {
        d += 2;
    }
    return x%d!=0;
}

int check(int i, int idx)
{
    int ch = a[idx];
    int d = 2;
    int br = 0;
    bool f = false;
    while(ch>1)
    {
        if(d>=2000&&prime(ch))
        {
            if(used[ch]==i-last+1) f = true;
            break;
        }
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br) if(used[d]==i-last+1) f = true;
        d++;
        br = 0;
    }
    if(f) return i-last;
    else return 0;
}

void used_fill(int i)
{
    //len = i-last;
    int ch = a[i];
    int d = 2;
    int br = 0;
    while(ch>1)
    {
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br) used[d]++;
        d++;
        br = 0;
    }
}

void used_del(int i)
{
    int ch = a[i];
    int d = 2;
    int br = 0;
    while(ch>1)
    {
        while(ch%d==0)
        {
            ch /= d;
            br++;
        }
        if(br) used[d]--;
        d++;
        br = 0;
    }
}

void solve()
{
    int nb1 = g[1][0];
    int nb2 = 0;
    if(g[1].size()==2) nb2 = g[1][1];
    dfs_par1(nb1,1);
    dfs_par2(nb2,1);
    //v.push_back(0);
    //reverse(v1.begin(),v1.end());
    //for(int i=0;i<v1.size();i++) v.push_back(v1[i]);
    //v.push_back(1);
    //if(nb2!=0) for(int i=0;i<v2.size();i++) v.push_back(v2[i]);
    last = -1;
    used_fill(1);
    //for(int i=0;i<v1.size();i++) cout << v1[i] << " ";
    //cout << endl;
    for(int i=0;i<v1.size();i++)
    {
        used_fill(v1[i]);
        while(last<i&&check(i,v1[i])==0)
        {
            if(last==-1) used_del(1);
            else used_del(v1[last]);
            last++;
        }
        //cout << last << " " << i << endl;
        ans = max(ans,i-last);
    }
    //cout << ans << endl;
    if(nb2==0)
    {
        cout << ans << endl;
        return;
    }
    //cout << "++++" << endl;
    memset(used,0,sizeof(used));
    last = -1;
    used_fill(1);
    for(int i=0;i<v2.size();i++)
    {
        used_fill(v2[i]);
        while(last<i&&check(i,v2[i])==0)
        {
            if(last==-1) used_del(1);
            else used_del(v1[last]);
            last++;
        }
        ans = max(ans,i-last);
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
