#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 51;
const int maxm = 51;

int n,k;
int a[maxn][maxn];
long long pref[maxn][maxn];
long long dp[maxn][maxn][maxn];
long long ans = -1e18;

void read()
{
    cin >> n >> k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> a[i][j];
            pref[i][j] = pref[i][j-1] + pref[i-1][j] - pref[i-1][j-1] + a[i][j];
        }
    }
}

long long rect(int i, int j)
{
    swap(i,j);
    return pref[i][i] - pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=i;j++)
        {
            long long pom = pref[i][i] -pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
            dp[j][i][1] = pom;
            ans = max(ans,pom);
        }
    }
    for(int q=2;q<=k;q++)
    {
        for(int r=1;r<=n;r++)
        {
            for(int l=1;l<=r;l++)
            {
                for(int r2=1;r2<r;r2++)
                {
                    for(int l2=1;l2<=(r2,l-1);l2++)
                    {
                        long long pom = rect(l,r);
                        if(l<=r2) pom -= rect(l,r2);
                        dp[l][r][q] = max(dp[l][r][q],pom+dp[l2][r2][q-1]);
                        ans = max(ans,dp[l][r][q]);
                    }
                }
            }
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout << dp[i][j][1] << " ";
        }
        cout << endl;
    }*/
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
