#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 151;
const int maxm = 151;

int n,k;
int a[maxn][maxn];
long long pref[maxn][maxn];
long long dp[maxn][maxn][maxn];
long long maxs[maxn][maxn][maxn];
long long ans;

void read()
{
    cin >> n >> k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> a[i][j];
            pref[i][j] = pref[i][j-1] + pref[i-1][j] - pref[i-1][j-1] + a[i][j];
        }
    }
}

long long rect(int i, int j)
{
    swap(i,j);
    return pref[i][i] - pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
}

void solve()
{
    for(int i=1;i<=n;i++) maxs[0][i][1] = -1e18;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=i;j++)
        {
            maxs[j][i][1] = max((long long)-1e18,maxs[j-1][i][1]);
            dp[j][i][1] = -1e18;
            long long pom = pref[i][i] -pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
            dp[j][i][1] = max(dp[j][i][1],pom);
            maxs[j][i][1] = max(maxs[j][i][1],dp[j][i][1]);
            ans = max(ans,dp[j][i][1]);

        }
    }
    for(int q=2;q<=k;q++)
    {
        for(int r=1;r<=n;r++)
        {
            maxs[0][r][q] = -1e18;
            for(int l=1;l<=r;l++)
            {
                maxs[l][r][q] = max((long long)-1e18,maxs[l-1][r][q]);
                dp[l][r][q] = -1e18;
                for(int r2=1;r2<r;r2++)
                {
                    int gr = min(r2,l-1);
                    long long pom = rect(l,r);
                    if(l<=r2) pom -= rect(l,r2);
                    dp[l][r][q] = max(dp[l][r][q],pom+maxs[gr][r2][q-1]);
                    maxs[l][r][q] = max(maxs[l][r][q],dp[l][r][q]);
                    ans = max(ans,dp[l][r][q]);
                }
            }
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout << dp[i][j][1] << " ";
        }
        cout << endl;
    }*/
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
