#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 701;
const int maxm = 701;

int n,k;
int a[maxn][maxn];
long long pref[maxn][maxn];
long long dp[maxn][maxn];
long long maxs[maxn][maxn];
long long ans;

void read()
{
    cin >> n >> k;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> a[i][j];
            pref[i][j] = pref[i][j-1] + pref[i-1][j] - pref[i-1][j-1] + a[i][j];
        }
    }
}

long long rect(int i, int j)
{
    swap(i,j);
    return pref[i][i] - pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
}

void solve()
{
    for(int i=1;i<=n;i++) maxs[0][i] = -1e18;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=i;j++)
        {
            maxs[j][i] = max((long long)-1e18,maxs[j-1][i]);
            dp[j][i] = -1e18;
            long long pom = pref[i][i] -pref[i][j-1] - pref[j-1][i] + pref[j-1][j-1];
            dp[j][i] = max(dp[j][i],pom);
            maxs[j][i] = max(maxs[j][i],dp[j][i]);
            ans = max(ans,dp[j][i]);
        }
    }
    for(int r=1;r<=n;r++)
    {
        maxs[0][r] = -1e18;
        for(int l=1;l<=r;l++)
        {
            maxs[l][r] = max((long long)-1e18,max(maxs[l][r],maxs[l-1][r]));
            //dp[l][r] = -1e18;
            for(int r2=1;r2<r;r2++)
            {
                int gr = min(r2,l-1);
                long long pom = rect(l,r);
                if(l<=r2) pom -= rect(l,r2);
                dp[l][r] = max(dp[l][r],pom+maxs[gr][r2]);
                maxs[l][r] = max(maxs[l][r],dp[l][r]);
                ans = max(ans,dp[l][r]);
            }
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout << dp[i][j][1] << " ";
        }
        cout << endl;
    }*/
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
